package cn.com.ctop.alarm.modules.controller;

import cn.com.ctop.alarm.modules.entity.AlarmEventRule;
import cn.com.ctop.alarm.modules.service.IAlarmEventRuleService;
import cn.com.ctop.common.module.annotation.AutoLog;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 预警事件规则表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-10-29
 */
@Slf4j
@Api(tags = "预警事件规则表")
@RestController
@RequestMapping("/alarm/alarmEventRule")
public class AlarmEventRuleController {
    @Autowired
    private IAlarmEventRuleService alarmEventRuleService;

    /**
     * 分页列表查询
     *
     * @param alarmEventRule
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "预警事件规则表-分页列表查询")
    @ApiOperation(value = "预警事件规则表-分页列表查询", notes = "预警事件规则表-分页列表查询")
    @GetMapping(value = "/list")
    public Result<PageInfo<AlarmEventRule>> queryPageList(AlarmEventRule alarmEventRule,
                                                          @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                          @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                          HttpServletRequest req) {
        Result<PageInfo<AlarmEventRule>> result = new Result<>();
        PageHelper.startPage(pageNo, pageSize);
        PageInfo<AlarmEventRule> pageList = alarmEventRuleService.selectListPage(alarmEventRule);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 分页列表查询
     *
     * @param alarmEventRule
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "获取规则运行记录数据-分页列表查询")
    @ApiOperation(value = "获取规则运行记录数据-分页列表查询", notes = "获取规则运行记录数据-分页列表查询")
    @GetMapping(value = "/getRunningRecords")
    public Result<PageInfo<AlarmEventRule>> getRunningRecord(AlarmEventRule alarmEventRule,
                                                             @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                             @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                             HttpServletRequest req) {
        Result<PageInfo<AlarmEventRule>> result = new Result<>();
        PageHelper.startPage(pageNo, pageSize);
        PageInfo<AlarmEventRule> pageList = alarmEventRuleService.queryRunningRecordPage(alarmEventRule);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param alarmEventRule
     * @return
     */
    @AutoLog(value = "预警事件规则表-添加")
    @ApiOperation(value = "预警事件规则表-添加", notes = "预警事件规则表-添加")
    @PostMapping(value = "/add")
    public Result<Object> addAlarmEventRule(@RequestBody JSONObject obj) {
        Result<Object> result = new Result<>();
        try {
            result = alarmEventRuleService.addAlarmEventRule(obj);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param alarmEventRule
     * @return
     */
    @AutoLog(value = "预警事件规则表-编辑")
    @ApiOperation(value = "预警事件规则表-编辑", notes = "预警事件规则表-编辑")
    @PostMapping(value = "/edit")
    public Result<Object> editAlarmEventRule(@RequestBody JSONObject obj) {
        Result<Object> result = new Result<>();
        try {
            result = alarmEventRuleService.editAlarmEventRule(obj);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "预警事件规则表-通过id删除")
    @ApiOperation(value = "预警事件规则表-通过id删除", notes = "预警事件规则表-通过id删除")
    @GetMapping(value = "/delete")
    public Result<?> delete(Long id) {
        try {
            alarmEventRuleService.deleteById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "预警事件规则表-批量删除")
    @ApiOperation(value = "预警事件规则表-批量删除", notes = "预警事件规则表-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<AlarmEventRule> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<AlarmEventRule> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.alarmEventRuleService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "预警事件规则表-通过id查询")
    @ApiOperation(value = "预警事件规则表-通过id查询", notes = "预警事件规则表-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<AlarmEventRule> queryById(@RequestParam(name = "id", required = true) Long id) {
        Result<AlarmEventRule> result = new Result<>();
        AlarmEventRule alarmEventRule = alarmEventRuleService.selectById(id);
        if (alarmEventRule == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(alarmEventRule);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<AlarmEventRule> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                AlarmEventRule alarmEventRule = JSON.parseObject(deString, AlarmEventRule.class);
                queryWrapper = QueryGenerator.initQueryWrapper(alarmEventRule, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<AlarmEventRule> pageList = alarmEventRuleService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "预警事件规则表列表");
        mv.addObject(NormalExcelConstants.CLASS, AlarmEventRule.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("预警事件规则表列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<AlarmEventRule> listAlarmEventRules = ExcelImportUtil.importExcel(file.getInputStream(), AlarmEventRule.class, params);
                alarmEventRuleService.saveBatch(listAlarmEventRules);
                return Result.ok("文件导入成功！数据行数:" + listAlarmEventRules.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
